<?xml version="1.0"?>
<!--
#
# System:		flash chart
#
# File:			dd_chart.xsl
#
# Title:		Flash chart
#
# Description:  
# 				Display a flashchart
#
# History:
# 12-12-2006	RuBr	Creator 
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="xml"/>
	
	<xsl:variable name="newline">
		<xsl:text>
</xsl:text>
	</xsl:variable>
	
	
	<xsl:template match="/diag">
		<xsl:for-each select="chart">
			<chart>
				<license>E1XHK8DOI6L.HSK5T4Q79KLYCK07EK</license>
				<xsl:if test="./axis_category">		<xsl:copy-of select="./axis_category"/>		</xsl:if>
				<xsl:if test="./axis_ticks">		<xsl:copy-of select="./axis_ticks"/>		</xsl:if>
				<xsl:if test="./axis_value">		<xsl:copy-of select="./axis_value"/>		</xsl:if>
				<xsl:if test="./chart_border">		<xsl:copy-of select="./chart_border"/>		</xsl:if>
				<xsl:if test="./chart_grid_h">		<xsl:copy-of select="./chart_grid_h"/>		</xsl:if>
				<xsl:if test="./chart_grid_v">		<xsl:copy-of select="./chart_grid_v"/>		</xsl:if>
				<xsl:if test="./chart_pref">		<xsl:copy-of select="./chart_pref"/>		</xsl:if>
				<xsl:if test="./chart_rect">		<xsl:copy-of select="./chart_rect"/>		</xsl:if>
				<xsl:if test="./chart_transition">	<xsl:copy-of select="./chart_transition"/>	</xsl:if>
				<xsl:if test="./chart_type">		<xsl:copy-of select="./chart_type"/>		</xsl:if>
				<xsl:if test="./chart_value">		<xsl:copy-of select="./chart_value"/>		</xsl:if>
				<xsl:if test="./draw">			<xsl:copy-of select="./draw"/>			</xsl:if>
				<xsl:if test="./legend_label">		<xsl:copy-of select="./legend_label"/>		</xsl:if>
				<xsl:if test="./legend_rect">		<xsl:copy-of select="./legend_rect"/>		</xsl:if>
				<xsl:if test="./legend_transition">	<xsl:copy-of select="./legend_transition"/>	</xsl:if>
				<xsl:if test="./link">			<xsl:copy-of select="./link"/>			</xsl:if>
				<xsl:if test="./live_update">		<xsl:copy-of select="./live_update"/>		</xsl:if>
				<xsl:if test="./series_color">		<xsl:copy-of select="./series_color"/>		</xsl:if>
				<xsl:if test="./series_explode">	<xsl:copy-of select="./series_explode"/>	</xsl:if>
				<xsl:if test="./series_gap">		<xsl:copy-of select="./series_gap"/>		</xsl:if>
				<xsl:if test="./series_switch">		<xsl:copy-of select="./series_switch"/>		</xsl:if>

				<chart_data>
					<row>
						<null/>
						<xsl:for-each select="./chart_data/header">
							<xsl:choose>
								<xsl:when test="contains(.,./@breakChar) and ./@breakChar[. != '']">
									<string>
										<xsl:call-template name="replace-string">
											<xsl:with-param name="text" select="normalize-space(./text())"/>
											<xsl:with-param name="from"><xsl:value-of select="./@breakChar"/></xsl:with-param>
											<xsl:with-param name="to"><xsl:value-of select="$newline"/></xsl:with-param>
										</xsl:call-template>
									</string>
								</xsl:when>
								<xsl:otherwise>
									<string>
										<xsl:value-of select="."/>
									</string>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
					</row>
					<xsl:for-each select="./chart_data/item">
						<row>
							<string><xsl:value-of select="@value" /></string>
							<xsl:for-each select="./label">
								<xsl:choose>
									<xsl:when test="normalize-space(./text()) != ''">
										<number><xsl:value-of select="."/></number>
									</xsl:when>
									<xsl:otherwise><null /></xsl:otherwise>
								</xsl:choose>
							</xsl:for-each>
						</row>
					</xsl:for-each>
				</chart_data>

				<xsl:if test="./chart_value_text">
					<chart_value_text>
						<xsl:for-each select="./chart_value_text/item">
							<row>
								<xsl:for-each select="./label">
									<xsl:choose>
										<xsl:when test=". != '' and contains(.,./@breakChar) and ./@breakChar[. != '']">
											<string>
												<xsl:call-template name="replace-string">
													<xsl:with-param name="text" select="normalize-space(./text())"/>
													<xsl:with-param name="from"><xsl:value-of select="./@breakChar"/></xsl:with-param>
													<xsl:with-param name="to"><xsl:value-of select="$newline"/></xsl:with-param>
												</xsl:call-template>
											</string>
										</xsl:when>
										<xsl:when test=". != ''">
											<string>
												<xsl:value-of select="."/>
											</string>
										</xsl:when>
										<xsl:otherwise>
											<null/>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:for-each>
							</row>
						</xsl:for-each>
					</chart_value_text>
				</xsl:if>

			</chart>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="replace-string">
		<xsl:param name="text"/>
		<xsl:param name="from"/>
		<xsl:param name="to"/>
		<xsl:choose>
			<xsl:when test="contains($text, $from)">
				<xsl:variable name="before" select="substring-before($text, $from)"/>
				<xsl:variable name="after" select="substring-after($text, $from)"/>
				<xsl:variable name="prefix" select="concat($before, $to)"/>
				<xsl:value-of select="$before"/>
				<xsl:value-of select="$to"/>
				<xsl:call-template name="replace-string">
					<xsl:with-param name="text" select="$after"/>
					<xsl:with-param name="from" select="$from"/>
					<xsl:with-param name="to" select="$to"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
