<?xml version="1.0" encoding="UTF-8"?>
<!--
System: Dynamic Dialogue (DD) System file

Component: 

Description:

-->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="attr[@fieldtype='submit_button' or @fieldtype='reset_button' or @fieldtype='onclick_button' or @fieldtype='hard_url_button' or 
			@fieldtype='soft_url_button' or @fieldtype='popup_win_button' or @fieldtype='graph_submit_button' or @fieldtype='graph_onclick_button' or @fieldtype='confirm_button']">
		<xsl:if test="not(@mode) and (not(@lock) or not(contains(@lock,'true')))">
			<xsl:choose>
				<xsl:when test="@module[.!='']">
					<xsl:variable name="module" select="@module"/>
					<xsl:if test="contains($settings/dd_mod/module[@name=$module],'true')">
						<xsl:call-template name="button"/>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="button"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>	
	</xsl:template>

	<xsl:template name="labelAsButton">	
		<a>
			<xsl:attribute name="id">
				<xsl:value-of select="generate-id()" />
			</xsl:attribute>
			<xsl:attribute name="class">
				<xsl:text>table_inner </xsl:text>
				<xsl:if test="@linkclass">
					<xsl:value-of select="@linkclass"/>
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>javascript:document.getElementById('</xsl:text>
				<xsl:value-of select="../../@id"/>
				<xsl:text>').value='</xsl:text>
				<xsl:value-of select="../@value"/>
				<xsl:text>';</xsl:text>
				<xsl:call-template name="make_submit">
					<xsl:with-param name="id">
						<xsl:value-of select="normalize-space(content)"/>
					</xsl:with-param>
					<xsl:with-param name="target">
						<xsl:value-of select="@target"/>
					</xsl:with-param>
					<xsl:with-param name="expire">
						<xsl:value-of select="@expire"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:attribute>
			<xsl:if test="@tooltip[.!='']">
				<xsl:attribute name="onmouseover">displayTooltipContent('<xsl:value-of select="generate-id(.)" />', '<xsl:value-of select="@tooltip"/>');</xsl:attribute>
			</xsl:if>
			[<xsl:choose>
				<xsl:when test="@button_label[.!='']">
					<xsl:value-of select="@button_label"/>
				</xsl:when>
				<xsl:when test="@label[.!='']">
					<xsl:value-of select="@label"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@id"/>
				</xsl:otherwise>
			</xsl:choose>]
		</a>
	</xsl:template>

	<xsl:template name="button">	
		<xsl:if test="not(contains(@lock,'true')) or not(@lock)">
			<input>		
				<xsl:attribute name="id">
					<xsl:value-of select="generate-id(.)"/>
				</xsl:attribute>
				<xsl:if test="@id[.!='']">
					<xsl:attribute name="name">
						<xsl:value-of select="@id"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="class">
					<xsl:text>btn </xsl:text>
					<xsl:value-of select="@mode" />
					<xsl:if test="@class[.!='']">
						<xsl:text> </xsl:text><xsl:value-of select="@class" />
					</xsl:if>
				</xsl:attribute>

				<xsl:if test="@title">
					<xsl:attribute name="title">
						<xsl:value-of select="@title"/>
					</xsl:attribute>
				</xsl:if>			
				<xsl:if test="@disabled='true'">
					<xsl:attribute name="disabled">true</xsl:attribute>
				</xsl:if>			

				<xsl:choose>
					<xsl:when test="@button_label[.!='']">
						<xsl:attribute name="value">
							<xsl:value-of select="@button_label"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:when test="@label[.!='']">
						<xsl:attribute name="value">
							<xsl:value-of select="@label"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="value">
							<xsl:value-of select="@id"/>
						</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>

				<xsl:choose>
					<!--	 Think think think... see if we can live without default focus specialy handy for login buttons		-->
					<xsl:when test="@fieldtype[.='reset_button']">
						<xsl:attribute name="type">reset</xsl:attribute>
					</xsl:when>
					<xsl:when test="@fieldtype[.='graph_submit_button']">
						<xsl:attribute name="type">image</xsl:attribute>
						<xsl:attribute name="src">
							<xsl:value-of select="@href"/>
						</xsl:attribute>
						<xsl:attribute name="onclick">
							<xsl:call-template name="make_submit">
								<xsl:with-param name="id">
									<xsl:value-of select="@id"/>
								</xsl:with-param>
								<xsl:with-param name="target">
									<xsl:value-of select="@target"/>
								</xsl:with-param>
								<xsl:with-param name="expire"/>
							</xsl:call-template>return false;
						</xsl:attribute>
					</xsl:when>
					<xsl:when test="@fieldtype[.='graph_onclick_button']">
						<xsl:attribute name="type">image</xsl:attribute>
						<xsl:attribute name="src">
							<xsl:value-of select="@href"/>
						</xsl:attribute>
						<xsl:attribute name="onclick">
							<xsl:value-of select="normalize-space(content)"/>
						</xsl:attribute>
					</xsl:when>
					<!--<xsl:when test="@fieldtype[.='confirm_button']">
						<xsl:attribute name="class">confirm_button</xsl:attribute>
						<xsl:call-template name="gen_button"/>
					</xsl:when>
					--><xsl:otherwise>
						<xsl:call-template name="gen_button"/>
					</xsl:otherwise>
				</xsl:choose>
			</input>
		</xsl:if>
	</xsl:template>


	<!-- The defintion for the button of fieldtype: onclick_button and hard_url_button and soft_url_button and client_submit_button-->
	<xsl:template name="gen_button">
		<xsl:choose>
			<xsl:when test="@default[.='true']">
				<xsl:attribute name="type">submit</xsl:attribute>	
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="@image[.!='']">
						<xsl:attribute name="type">image</xsl:attribute>
						<xsl:attribute name="src">
							<xsl:value-of select="@image"/>
						</xsl:attribute>
					</xsl:when>	
					<xsl:otherwise>
						<xsl:attribute name="type">button</xsl:attribute>	
					</xsl:otherwise>
				</xsl:choose>


				<xsl:choose>
					<xsl:when test="@fieldtype[.='submit_button']">
						<xsl:attribute name="onclick">
							this.disabled=true;
							<xsl:if test="@validation[.='off']">
								document.getElementById('novalidation').value = 'true';
							</xsl:if>
							<xsl:call-template name="make_submit">
								<xsl:with-param name="id">
									<xsl:value-of select="@id"/>
								</xsl:with-param>
								<xsl:with-param name="target">
									<xsl:value-of select="@target"/>
								</xsl:with-param>
								<xsl:with-param name="expire">
									<xsl:value-of select="@expire"/>
								</xsl:with-param>
							</xsl:call-template>
							this.disabled=false;
						</xsl:attribute>
					</xsl:when>
					<xsl:when test="@fieldtype[.='confirm_button']">
						<xsl:attribute name="onclick">
							if ( confirm( 'Are you sure?' ) ) {

								this.disabled=true;
							<xsl:if test="@validation[.='off']">
									document.getElementById('novalidation').value = 'true';
							</xsl:if>
							<xsl:call-template name="make_submit">
								<xsl:with-param name="id">
									<xsl:value-of select="@id"/>
								</xsl:with-param>
								<xsl:with-param name="target">
									<xsl:value-of select="@target"/>
								</xsl:with-param>
								<xsl:with-param name="expire">
									<xsl:value-of select="@expire"/>
								</xsl:with-param>
							</xsl:call-template>
								this.disabled=false;
							}
						</xsl:attribute>

					</xsl:when>
					<xsl:when test="@fieldtype[.='onclick_button']">
						<xsl:attribute name="onclick">
							<xsl:value-of select="normalize-space(content)"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="onclick">
							<xsl:for-each select="content[.!='']">
								<xsl:choose>
									<xsl:when test="../@fieldtype[.='popup_win_button']">
										<xsl:call-template name="make_link">
											<xsl:with-param name="link">
												<xsl:value-of select="." />
											</xsl:with-param>
											<xsl:with-param name="target">popup</xsl:with-param>
										</xsl:call-template>
									</xsl:when>	
									<xsl:otherwise>
										<xsl:call-template name="make_link">
											<xsl:with-param name="link">
												<xsl:value-of select="." />
											</xsl:with-param>
											<xsl:with-param name="target">
												<xsl:value-of select="@target"/>
											</xsl:with-param>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:for-each>
							<xsl:if test="@onclick[.!='']">
								<xsl:value-of select="@onclick" />
							</xsl:if>
						</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>	

</xsl:stylesheet>


