<?xml version="1.0" encoding="UTF-8"?>
<!--
System: Dynamic Dialogue (DD) System file

Component: 

Description:

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="attr[@fieldtype='htmledit']">
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">			
			<textarea class="textarea_item">
				<xsl:if test="@id[.!='']"><xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>
   					<xsl:if test="@id[.!='']"><xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>
       				<xsl:if test="@cols[.!='']"><xsl:attribute name="cols"><xsl:value-of select="@cols"/></xsl:attribute></xsl:if>
       				<xsl:if test="@rows[.!='']"><xsl:attribute name="rows"><xsl:value-of select="@rows"/></xsl:attribute></xsl:if>
				<xsl:if test="@readonly[.='true']"><xsl:attribute name="readonly"/></xsl:if>								
				<xsl:if test="@label[.!='']"><xsl:attribute name="label"><xsl:value-of select="@label"/></xsl:attribute></xsl:if>
				<xsl:if test="@maxlength[.!='']">
					<xsl:attribute name="maxlength"><xsl:value-of select="@maxlength"/></xsl:attribute>
					<xsl:attribute name="onblur">
						<xsl:text>chkLen( this, </xsl:text><xsl:value-of select="@maxlength"/><xsl:text>)</xsl:text>
					</xsl:attribute>
				</xsl:if>						
				<xsl:choose>
					<xsl:when test="normalize-space(content)=''"><xsl:value-of select="@default"/></xsl:when>	
					<xsl:otherwise><xsl:copy-of select="./content/text()" /></xsl:otherwise>
				</xsl:choose>
			</textarea>
			<script type="text/javascript">
				 var oEdit1 = new InnovaEditor("oEdit1");
				 oEdit1.mode="XHTMLBody";
				 <xsl:choose>
				 	<xsl:when test="@width!=''">
				 		oEdit1.width=<xsl:value-of select="@width"/>;
				 	</xsl:when>
				 	<xsl:otherwise>
				 		oEdit1.width=775;
				 	</xsl:otherwise>
				 </xsl:choose>
				 <xsl:choose>
				 	<xsl:when test="@height!=''">
				 		oEdit1.height=<xsl:value-of select="@height"/>;
				 	</xsl:when>
				 	<xsl:otherwise>
				 		oEdit1.height=350;
				 	</xsl:otherwise>
				 </xsl:choose>
				<xsl:choose>
				 	<xsl:when test="@save!=''">
				 		oEdit1.height=<xsl:value-of select="@save"/>;
				 	</xsl:when>
				 	<xsl:otherwise>
				 		oEdit1.btnSave=false;
				 	</xsl:otherwise>
				 </xsl:choose>	
				 // apply CSS style
				 oEdit1.btnStyles=true;
				
				 // set the asset manager

 				 // set LineBreaks as to
				 oEdit1.useBR=false;
				 oEdit1.userDIV=true;

				 //Enable buttons
				 oEdit1.btnFullScreen=false;
				 oEdit1.btnPreview=false;
				 oEdit1.btnSearch=false;
				 oEdit1.btnBookmark=false;
				 oEdit1.btnTextFormatting=false;
				 oEdit1.btnListFormatting=false;
				 oEdit1.btnBoxFormatting=false;
				 oEdit1.btnParagraphFormatting=false;
				 oEdit1.btnCssText=false;
				 oEdit1.btnStyles=false;
				 oEdit1.useTagSelector=false;
				 oEdit1.btnForm=false;
				 oEdit1.btnPrint=true;
				 oEdit1.btnPasteText=true;
				 oEdit1.btnLTR=true;
				 oEdit1.btnRTL=true;
				 oEdit1.btnSpellCheck=false;
				 oEdit1.btnStrikethrough=true;
				 oEdit1.btnSuperscript=true;
				 oEdit1.btnSubscript=true;
				 oEdit1.btnClearAll=true;
				 					
				 oEdit1.REPLACE("<xsl:value-of select="@id"/>");	
			</script>	
		</xsl:if>	
	</xsl:template>
</xsl:stylesheet>

