<?xml version="1.0" encoding="UTF-8"?>
<!--
System: Dynamic Dialogue (DD) System file

Component: 

Description:

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="attr[@fieldtype='picturebox' or @fieldtype='image_list']">
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">
			<xsl:variable name="groupname">lb_<xsl:value-of select="generate-id()" /></xsl:variable>
			<input type="hidden" name="component_onload">
				<xsl:attribute name="value">
					var <xsl:value-of select="$groupname" />;
				</xsl:attribute>
			</input>
			<div class="picture_box_wrapper">
				<xsl:for-each select="item">						
					<div>
						<xsl:attribute name="id">pb_<xsl:value-of select="$groupname" /></xsl:attribute>
						<xsl:attribute name="class"><xsl:text>picture_box</xsl:text>
							<xsl:if test="position() = 1">
								<xsl:text> first_picture</xsl:text>
							</xsl:if>
						</xsl:attribute>
						<xsl:choose>
							<xsl:when test="@attr[.='true']">
								<xsl:apply-templates select="attr"/>
							</xsl:when>
							<xsl:otherwise>
								<img><xsl:attribute name="src"><xsl:value-of select="."/></xsl:attribute></img>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:if test="position() = 1">
							<xsl:if test="count(../item[not(@attr) or @attr!='true']) > 0">
								<div class="magnify"><img src="images/magnify.png"><xsl:attribute name="onclick"><xsl:value-of select="$groupname" />.show();</xsl:attribute></img></div>
							</xsl:if>
							<div class="edit">
								<xsl:value-of select="count(../item[not(@attr) or @attr!='true'])" /><xsl:text> </xsl:text><xsl:value-of select="../@imagelabel" /><xsl:text> </xsl:text>
								<xsl:if test="count(../item[not(@attr) or @attr!='true']) > 0">
									<input class="table_inner" type="button">
										<xsl:attribute name="onclick"><xsl:value-of select="$groupname" />.show();</xsl:attribute>
										<xsl:attribute name="value"><xsl:value-of select="../@showlabel" /></xsl:attribute>
									</input>
									<xsl:text> | </xsl:text>
								</xsl:if>
								<input class="table_inner" type="button">
									<xsl:attribute name="value"><xsl:value-of select="../@editlabel" /></xsl:attribute>
									<xsl:attribute name="onclick">
										<xsl:call-template name="make_link">
											<xsl:with-param name="link"><xsl:value-of select="../@editlink" /></xsl:with-param>
											<xsl:with-param name="target"><xsl:value-of select="../@target"/></xsl:with-param>
										</xsl:call-template>
									</xsl:attribute>
								</input>
							</div>
						</xsl:if>
					</div>
				</xsl:for-each>
				<input type="hidden" name="component_onload">
					<xsl:attribute name="value">
						require(["dojo/ready", "dojox/image/Lightbox"], function(ready, Lightbox){
							ready(function(){
							<xsl:for-each select="item[not(@attr) or @attr!='true']">
								<xsl:choose>
									<xsl:when test="position() = 1">
										<xsl:value-of select="$groupname" /> = new Lightbox({
											group:"pb_<xsl:value-of select="$groupname" />", 
											href:"<xsl:value-of select="."/>",
											title : "Druk op ESC om te sluiten"});
										<xsl:value-of select="$groupname" />.startup();
									</xsl:when>
									<xsl:otherwise>
										var <xsl:value-of select="$groupname" />sub = new Lightbox({
											group:"pb_<xsl:value-of select="$groupname" />", 
											href:"<xsl:value-of select="."/>",
											title : "Druk op ESC om te sluiten"});
										<xsl:value-of select="$groupname" />sub.startup();
									</xsl:otherwise>
								</xsl:choose>
							</xsl:for-each>
							
							});
						});
					</xsl:attribute>
				</input>
			</div>
		</xsl:if>	
	</xsl:template>
	
	<xsl:template match="attr[@fieldtype='image']">
		<xsl:if test="@fieldtype[.='image']">
			<img alt="Foto" border="0">
				<xsl:if test="@class[.!='']">
					<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@width[.!='']">
					<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@height[.!='']">
					<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
				</xsl:if>
				<xsl:attribute name="style">
					<xsl:if test="@width[.!='']">width:<xsl:value-of select="@width"/>;</xsl:if>
					<xsl:if test="@height[.!='']">height:<xsl:value-of select="@height"/>;</xsl:if>
				</xsl:attribute>
				<xsl:if test="@tooltip!=''">
					<xsl:attribute name="onclick">hideTooltip();</xsl:attribute>
					<xsl:attribute name="onmouseout">hideTooltip();</xsl:attribute>
					<xsl:attribute name="onmouseover">
						<xsl:text>showTooltip(event,'</xsl:text>
						<xsl:value-of select="@tooltip" />
						<xsl:text>');</xsl:text>
					</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="src"><xsl:value-of select="./content"/></xsl:attribute>
			</img>
		</xsl:if>
	</xsl:template>
	
</xsl:stylesheet>
