<?xml version="1.0"?>
<!--
#
# System:	DD system style sheet (shared)
#
# File:			dd_error.xsl
#
# Title:		Error stylesheetDD Configuration file
#
# Description:  
# 		When an error occures dd generates an error xml file. This style sheet
#		parses this xml file and results in a html file which is dd response to the 
#  		error. DD passes the diag attributes user, id css and base and the 
#		content attribute has in  the text the error messages.
#
# History:
# 26-03-2001		RIKU	Creator 
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">

	<!-- The components -->
	<xsl:import href="chy/components.xsl"/>

	<xsl:param name="DD_CONFIG_FILE"/>
	<!--  Required to pass the context to the sylesheet from dd -->
	<xsl:param name="DD_DIAG_MODE"/>
	<xsl:variable name="settings" select="document($DD_CONFIG_FILE)/dd_config"/>
	
	<xsl:output method="xml" version="1.0" encoding="ISO-8859-1" indent="no" omit-xml-declaration="no" media-type="text/xml"></xsl:output>

<!-- The main template -->
<xsl:template match="/">
	<div id="overlaycontainer">
		<div style="z-index: 91; position:absolute; width: 100%; height: 100%; background-color: white; -khtml-opacity: 0.7; -moz-opacity: 0.7; opacity: 0.7; filter: alpha(opacity=70);"><xsl:comment>spacer</xsl:comment></div>
		<div id="errorbody">
			<!--<xsl:attribute name="id"><xsl:value-of select="//diag/@id" /></xsl:attribute>
			<xsl:attribute name="class">kpwindow_dialogborder_plain</xsl:attribute>-->
			<xsl:comment>dd_error_kpwindows.xsl</xsl:comment>
			<table class="border">
				<tr>
					<td class="bordertopleft"><xsl:comment>spacer</xsl:comment></td> 
					<td class="bordertopcenter"><xsl:comment>spacer</xsl:comment></td>
					<td class="bordertopright"><xsl:comment>spacer</xsl:comment></td>
				</tr>
				<tr>
					<td class="bordercontentleft"><xsl:comment>spacer</xsl:comment></td> 
					<td class="bordercontentcenter">
						<form  method="post" name="my">
							<div id="divMain">
								<table>
									<xsl:apply-templates/>
								</table>
								<a onclick="javascript:KPWindowHistoryBack(this);"><img class="closebutton" src="images/close.gif" />Back</a>
							</div>
						</form>
					</td>
					<td class="bordercontentright"><xsl:comment>spacer</xsl:comment></td>
				</tr>
				<td class="borderbottomleft"><xsl:comment>spacer</xsl:comment></td> 
				<td class="borderbottomcenter"><xsl:comment>spacer</xsl:comment></td>
				<td class="borderbottomright"><xsl:comment>spacer</xsl:comment></td>
			</table>
		</div>
	</div>
</xsl:template>

	<xsl:template match="diag">
		<span>
			<xsl:if test="@class[.!='']"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
			<b><xsl:value-of select="@name"/></b>
			<xsl:value-of select="@user"/>
		</span>	
		<span>
			<xsl:if test="@class[.!='']"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
			<xsl:apply-templates select="menuset" />
		</span>
		<span>
			<xsl:if test="@class[.!='']"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
			<ul id="errors">
				<li class="heading">Click with your mouse on the separate messages to focus on incorrect input</li>
			</ul> 
		</span>
		<xsl:apply-templates select="attrset"/>
	</xsl:template> 
</xsl:stylesheet>
