<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:json="http://json.org/"
	version="2.0">
	
	<xsl:import href="xml-to-json.xsl"/>
	
	<xsl:param name="cntxt"/>
	<xsl:param name="DD_CONFIG_FILE"/>
	<!--  Required to pass the context to the sylesheet from dd -->
	<xsl:param name="DD_DIAG_MODE"/>
	<xsl:variable name="settings" select="document($DD_CONFIG_FILE)/dd_config"/>
	
	<xsl:param name="skip-root" select="string('true')"/>
	
	<!--<xsl:output method="xml" version="1.0" encoding="ISO-8859-1" indent="no" omit-xml-declaration="no" media-type="text/xml"></xsl:output>-->
	<xsl:output method="text" version="1.0" encoding="UTF-8" media-type="text/plain"></xsl:output>

	<!-- add cntxt to root -->
	<xsl:template match="dynamicelements">
		<xsl:for-each select="element">
			<xsl:element name="{concat('q',name)}">
				<xsl:value-of select="value"/>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="item">
		<item>
			<xsl:copy-of select="./*[not(name()='dynamicelements')]"/>
			<xsl:apply-templates select="dynamicelements"/>
		</item>
	</xsl:template>
	
	<xsl:template match="/">
		<xsl:variable name="myjson">
			<json>
				<cntxt><xsl:value-of select="$cntxt"/></cntxt>
				
				<xsl:for-each select="diag/folder/folder">
					<xsl:sort select="@name"/>
					<item>
						<xsl:attribute name="id"><xsl:value-of select="../@name" /><xsl:value-of select="@name" />/</xsl:attribute>
						<xsl:attribute name="name"><xsl:value-of select="@name" /></xsl:attribute>
						<xsl:attribute name="parent"><xsl:value-of select="../@name" /></xsl:attribute>
						<xsl:attribute name="type">folder</xsl:attribute>
						<xsl:attribute name="children"><xsl:choose><xsl:when test="@doctype_id!=''">false</xsl:when><xsl:otherwise>true</xsl:otherwise></xsl:choose></xsl:attribute>
					</item>
				</xsl:for-each>
				<xsl:copy>
					<xsl:apply-templates select="diag/folder/folder"/>
				</xsl:copy>
				<xsl:copy-of select="json/*[not(name()='item')]"/>
			</json>
		</xsl:variable>
		<xsl:value-of select="json:generate($myjson/json)"/>
	</xsl:template>

</xsl:stylesheet>
