<?xml version="1.0" encoding="UTF-8"?>
<!--
System: Dynamic Dialogue (DD) System file

Component: 

Description:

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="attr[@fieldtype='date_picker']">
		<xsl:variable name="formid" select="$formid" />
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">
			
			<xsl:variable name="date-format">
				<xsl:choose>
					<xsl:when test="@format[.!='']"><xsl:value-of select="@format"/></xsl:when>
					<xsl:otherwise>%d-%m-%Y</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>			
			<xsl:variable name="value">
					<xsl:choose>
						<xsl:when test="normalize-space(content)!=''"><xsl:value-of select="content"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="@default"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>				
				<input type="text" class="span2" data-dojo-type="chy/form/DateTextBox">
				     <xsl:if test="@id[.!='']"><xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>										     
				     <xsl:if test="@id[.!='']"><xsl:attribute name="id"><xsl:value-of select="$formid"/>-<xsl:value-of select="@id"/></xsl:attribute></xsl:if>										     
				     <xsl:if test="@maxlength[.!='']"><xsl:attribute name="maxlength"><xsl:value-of select="@maxlength"/></xsl:attribute></xsl:if>
					<xsl:if test="@size[.!='']"><xsl:attribute name="size"><xsl:value-of select="@size"/></xsl:attribute></xsl:if>					
					<xsl:attribute name="value"><xsl:value-of select="$value"/></xsl:attribute>
					<xsl:attribute name="alt">
						<xsl:choose>
							<xsl:when test="@validate[.!='']"><xsl:value-of select="@validate"/></xsl:when>
							<xsl:otherwise><xsl:text>date|dd/mm/yyyy|-</xsl:text></xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:if test="@errortext[.!='']"><xsl:attribute name="emsg"><xsl:value-of select="@errortext"/></xsl:attribute></xsl:if>
					<xsl:if test="@pattern[.!='']"><xsl:attribute name="pattern"><xsl:value-of select="@pattern"/></xsl:attribute></xsl:if>
					<xsl:if test="@title[.!='']"><xsl:attribute name="onmouseover"><xsl:text>return escape('</xsl:text><xsl:value-of select="@title"/><xsl:text>');</xsl:text></xsl:attribute></xsl:if>
					<xsl:attribute name="data-dojo-props">
								name: "<xsl:value-of select="@id"/>",
								readonly: <xsl:choose>
											<xsl:when test="@readonly[.='true']">true</xsl:when>
											<xsl:otherwise>false</xsl:otherwise>
										</xsl:choose>,
								constraints : {datePattern:'dd-MM-yyyy', strict:true },						
								value: '<xsl:value-of select="$value"/>',
								formId:'<xsl:value-of select="$formid"/>'
							</xsl:attribute>
				</input>
		</xsl:if>
	</xsl:template>

	<xsl:template match="attr[@fieldtype='date_calendar']">
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">
			<xsl:call-template name="disp_label"/>
			<xsl:variable name="date-format">
				<xsl:choose>
					<xsl:when test="@format[.!='']"><xsl:value-of select="@format"/></xsl:when>
					<xsl:otherwise>DD-MM-YYYY</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>			
						
			<span>
				<xsl:if test="@class[.!='']"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
				<table cellspacing="0" cellpadding="0" border="0">
				<td align="left">
					<input type="hidden">
					     <xsl:if test="@id[.!='']"><xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>										     
					     <xsl:if test="@id[.!='']"><xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>										     
						<xsl:choose>
							<xsl:when test="normalize-space(content)!=''"><xsl:attribute name="value"><xsl:value-of select="content"/></xsl:attribute></xsl:when>
							<xsl:otherwise><xsl:attribute name="value"><xsl:value-of select="@default"/></xsl:attribute></xsl:otherwise>
						</xsl:choose>
					</input>
				</td>
				<td>
					<div>
						<xsl:attribute name="id">dv_<xsl:value-of select="@id"/></xsl:attribute>
					</div>
					<input type="hidden" name="component_onload">
						<xsl:attribute name="value">
							  function dateChanged_calendar(calendar) {
							  	var sDate = calendar.selection.print("%d-%m-%Y");
								var obj = document.getElementById('<xsl:value-of select="@id"/>');
								obj.value = sDate;
								<xsl:value-of select="@onClick"/>
							  }
						  	cal = kpwindow_runcalendar('<xsl:value-of select="@id"/>','%d-%m-%Y', dateChanged_calendar);
						  	dateChanged_calendar(cal);
						</xsl:attribute>
					</input>
							
				</td>
				</table>
			</span>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
