<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="attr[@fieldtype='gmaps']">
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">
			<xsl:if test="@id[.!='']">
				<div>
					<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
					<xsl:if test="@class[.!='']"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
				</div>
				
				<input type="hidden" name="component_onload">
					<xsl:attribute name="value">
						function initializeGmaps(){
							var latlng = new google.maps.LatLng(<xsl:value-of select="@latitude"/>, <xsl:value-of select="@longitude"/>); 
							var myOptions = { 
  								zoom: <xsl:value-of select="@zoom"/>, 
  								center: latlng, 
  								mapTypeId: google.maps.MapTypeId.<xsl:value-of select="@maptype"/> 
							}; 
							var map = new google.maps.Map(document.getElementById("<xsl:value-of select="@id"/>"), myOptions);
							
							<xsl:for-each select="marker">
								new google.maps.Marker({
									position: new google.maps.LatLng(<xsl:value-of select="@latitude"/>, <xsl:value-of select="@longitude"/>),
									map: map,
									title:"<xsl:value-of select="@title"/>"<xsl:if test="@image!=''">,
									icon: "<xsl:value-of select="@image"/>"</xsl:if>
								});
							</xsl:for-each>
						}
						var script = document.createElement("script");
						script.type = "text/javascript";
						script.src = "http://maps.google.com/maps/api/js?sensor=false&amp;callback=initializeGmaps";
						document.getElementById("<xsl:value-of select="@id"/>").appendChild(script);
					</xsl:attribute>
				</input>
			</xsl:if>			
		</xsl:if>	
	</xsl:template>

</xsl:stylesheet>
