<?xml version="1.0" encoding="UTF-8"?>
<!--
System: Dynamic Dialogue (DD) System file

Component: 

Description:

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:template match="attr[@fieldtype='video']">
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">
			<xsl:call-template name="disp_label"/>
			<span>
				<xsl:if test="@class[.!='']"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
				<xsl:if test="@id[.!='']">
					<video>
						<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
						<xsl:attribute name="src"><xsl:value-of select="content"/></xsl:attribute>
						
						<xsl:choose>
							<xsl:when test="@controls[.!='']">
								<xsl:attribute name="controls"><xsl:value-of select="@width" /></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="controls">true</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when test="@autoplay[.!='']">
								<xsl:attribute name="autoplay"><xsl:value-of select="@width" /></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="autoplay">true</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when test="@width[.!='']">
								<xsl:attribute name="width"><xsl:value-of select="@width" /></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="width">100%</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when test="@height[.!='']">
								<xsl:attribute name="height"><xsl:value-of select="@height" /></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="height">98%</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
						Your browser does not support the HTML 5 video tag.
					</video>
				</xsl:if>
			</span>				
		</xsl:if>	
	</xsl:template>

</xsl:stylesheet>
