<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xl="http://www.innovationinvestments.nl/layout" version="1.0"  xmlns:exsl="http://exslt.org/common" extension-element-prefixes="exsl">


<xsl:template match="xl:block">
	<xsl:param name="dataset" />
	<xsl:variable name="formid" select="$formid" />
	<div>
		<xsl:attribute name="id"><xsl:value-of select="$formid"/>-<xsl:value-of select="generate-id()"/></xsl:attribute>
		<xsl:choose>
			<xsl:when test="@type='titlepane'">
				<xsl:variable name="titlepaneopen">
					<xsl:choose>
						<xsl:when test="@open[.='true']">true</xsl:when>
						<xsl:otherwise>false</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="titlepanetoggleable">
					<xsl:choose>
						<xsl:when test="@toggleable[.='false']">false</xsl:when>
						<xsl:otherwise>true</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:attribute name="data-dojo-type">dijit/TitlePane</xsl:attribute>
				<xsl:attribute name="data-dojo-props">
							toggleable: <xsl:value-of select="$titlepanetoggleable" />, 
							open: <xsl:value-of select="$titlepaneopen" />,
							title: '<xsl:value-of select="@title" />'
				</xsl:attribute>
			</xsl:when>
		</xsl:choose>
		<table class="table table-condensed table-bordered">
		<xsl:apply-templates>
			<xsl:with-param name="dataset" select="$dataset" />
		</xsl:apply-templates>
		</table>
	</div>
</xsl:template>

<xsl:template match="xl:text">
	<xsl:param name="dataset" />
	<xsl:variable name="formid" select="$formid" />
	<td>
		<xsl:if test="@colspan[.!='']"><xsl:attribute name="colspan"><xsl:value-of select="@colspan" /></xsl:attribute></xsl:if>
		<xsl:if test="@rowspan[.!='']"><xsl:attribute name="rowspan"><xsl:value-of select="@rowspan" /></xsl:attribute></xsl:if>
		<xsl:attribute name="class">questiontextlabel <xsl:if test="@class[.!='']"><xsl:value-of select="@class" /></xsl:if></xsl:attribute>
		<xsl:copy-of select="node()" />
	</td>
</xsl:template>


<xsl:template match="xl:row">
	<xsl:param name="dataset" />
	<xsl:variable name="formid" select="$formid" />
	<tr>
		<xsl:apply-templates>
			<xsl:with-param name="dataset" select="$dataset" />
		</xsl:apply-templates>
	</tr>
</xsl:template>

<xsl:template match="xl:field">
	<xsl:param name="dataset" />
	<xsl:variable name="formid" select="$formid" />
	<xsl:if test="@id[.='-2']">
			<td>
				<xsl:if test="@colspan[.!='']"><xsl:attribute name="colspan"><xsl:value-of select="@colspan" /></xsl:attribute></xsl:if>
				<xsl:if test="@rowspan[.!='']"><xsl:attribute name="rowspan"><xsl:value-of select="@rowspan" /></xsl:attribute></xsl:if>
				<xsl:if test="@styleCSS[.!='']"><xsl:attribute name="style"><xsl:value-of select="@styleCSS" /></xsl:attribute></xsl:if>
				<xsl:value-of select="@htmlContent" disable-output-escaping="yes"/>
			</td>
	</xsl:if>
	<xsl:variable name="field_id" select="@id"/>
	
	
	
	<xsl:apply-templates select="$dataset/item[substring-after(@id,'-')=$field_id]">
		<xsl:with-param name="form_id" select="$dataset/@id" />
		<xsl:with-param name="overrides" select="." />
	</xsl:apply-templates>
</xsl:template>



</xsl:stylesheet>