<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
	xmlns:fn="http://www.w3.org/2005/02/xpath-functions">
	<xsl:output method="xml" encoding="utf-8"
		omit-xml-declaration="no" media-type="text/xml" indent="no" />
	<xsl:variable name="defaultTemplate">
		E:/etc/letters/vpv_ac_stmt.xml
	</xsl:variable>
	<xsl:param name="DD_DIAG_MODE" />
	<xsl:param name="DD_XSLT_PARAM" select="$defaultTemplate" />
	<!-- <xsl:param name="DD_CONFIG_FILE"/> -->
	<xsl:param name="cntxt" />

	<!-- <xsl:import href="template.util.xsl"/> -->

	<!-- voor test nu DD_XSTL_PARAM als var -->
	<xsl:variable name="template" select="document(/diag/letter)" />
	<xsl:variable name="values" select="/diag" />

	<xsl:preserve-space elements="pre" />

	<xsl:template match="/">
		<xsl:apply-templates select="$template/letter" />
	</xsl:template>

	<xsl:template match="letter">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">
			<!-- defines page layout -->
			<fo:layout-master-set>
				<xsl:if test="titlepage">
					<fo:simple-page-master master-name="first">
						<xsl:attribute name="page-height">
							<xsl:choose>
								<xsl:when test="@page-height">
									<xsl:value-of select="@page-height" />
								</xsl:when>
								<xsl:otherwise>29.69cm</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>
						<xsl:attribute name="page-width">
							<xsl:choose>
								<xsl:when test="@page-width">
									<xsl:value-of select="@page-width" />
								</xsl:when>
								<xsl:otherwise>21cm</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>
						<xsl:if test="@margin-top">
							<xsl:attribute name="margin-top">
								<xsl:value-of
								select="@margin-top" />
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="@margin-left">
							<xsl:attribute name="margin-left">
								<xsl:value-of
								select="@margin-left" />
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="@margin-right">
							<xsl:attribute name="margin-right">
								<xsl:value-of
								select="@margin-right" />
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="@margin-bottom">
							<xsl:attribute name="margin-bottom">
								<xsl:value-of
								select="@margin-bottom" />
							</xsl:attribute>
						</xsl:if>
						<fo:region-body>
							<xsl:if test="body/@margin-top">
								<xsl:attribute name="margin-top">
									<xsl:value-of
									select="body/@margin-top" />
								</xsl:attribute>
							</xsl:if>
							<xsl:if test="body/@margin-left">
								<xsl:attribute name="margin-left">
									<xsl:value-of
									select="body/@margin-left" />
								</xsl:attribute>
							</xsl:if>
							<xsl:if test="body/@margin-right">
								<xsl:attribute name="margin-right">
									<xsl:value-of
									select="body/@margin-right" />
								</xsl:attribute>
							</xsl:if>
							<xsl:if test="body/@margin-bottom">
								<xsl:attribute name="margin-bottom">
									<xsl:value-of
									select="body/@margin-bottom" />
								</xsl:attribute>
							</xsl:if>
						</fo:region-body>
						<fo:region-before>
							<xsl:if test="header/@height">
								<xsl:attribute name="extent">
									<xsl:value-of
									select="header/@height" />
								</xsl:attribute>
							</xsl:if>
						</fo:region-before>
						<fo:region-after>
							<xsl:if test="footer/@height">
								<xsl:attribute name="extent">
									<xsl:value-of
									select="footer/@height" />
								</xsl:attribute>
							</xsl:if>
						</fo:region-after>
					</fo:simple-page-master>
				</xsl:if>
				<fo:simple-page-master master-name="letters">
					<xsl:attribute name="page-height">
						<xsl:choose>
							<xsl:when test="@page-height">
								<xsl:value-of select="@page-height" />
							</xsl:when>
							<xsl:otherwise>29.69cm</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:attribute name="page-width">
						<xsl:choose>
							<xsl:when test="@page-width">
								<xsl:value-of select="@page-width" />
							</xsl:when>
							<xsl:otherwise>21cm</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:if test="@margin-top">
						<xsl:attribute name="margin-top">
							<xsl:value-of
							select="@margin-top" />
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@margin-left">
						<xsl:attribute name="margin-left">
							<xsl:value-of
							select="@margin-left" />
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@margin-right">
						<xsl:attribute name="margin-right">
							<xsl:value-of
							select="@margin-right" />
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@margin-bottom">
						<xsl:attribute name="margin-bottom">
							<xsl:value-of
							select="@margin-bottom" />
						</xsl:attribute>
					</xsl:if>
					<fo:region-body>
						<xsl:if test="body/@margin-top">
							<xsl:attribute name="margin-top">
								<xsl:value-of
								select="body/@margin-top" />
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="body/@margin-left">
							<xsl:attribute name="margin-left">
								<xsl:value-of
								select="body/@margin-left" />
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="body/@margin-right">
							<xsl:attribute name="margin-right">
								<xsl:value-of
								select="body/@margin-right" />
							</xsl:attribute>
						</xsl:if>
						<xsl:if test="body/@margin-bottom">
							<xsl:attribute name="margin-bottom">
								<xsl:value-of
								select="body/@margin-bottom" />
							</xsl:attribute>
						</xsl:if>
					</fo:region-body>
					<fo:region-before>
						<xsl:if test="header/@height">
							<xsl:attribute name="extent">
								<xsl:value-of
								select="header/@height" />
							</xsl:attribute>
						</xsl:if>
					</fo:region-before>
					<fo:region-after>
						<xsl:if test="footer/@height">
							<xsl:attribute name="extent">
								<xsl:value-of
								select="footer/@height" />
							</xsl:attribute>
						</xsl:if>
					</fo:region-after>
				</fo:simple-page-master>
			</fo:layout-master-set>

			<xsl:if test="titlepage">
				<fo:page-sequence master-reference="first" format="">
					<xsl:apply-templates select="titlepage/header" />
					<xsl:apply-templates select="titlepage/footer" />
					<xsl:apply-templates select="titlepage/body">
						<xsl:with-param name="first">true</xsl:with-param>
					</xsl:apply-templates>
				</fo:page-sequence>
			</xsl:if>

			<xsl:if test="toc">
				<fo:page-sequence master-reference="letters" format="i">
					<xsl:apply-templates select="header" />
					<xsl:apply-templates select="footer" />
					<xsl:apply-templates select="toc" />

				</fo:page-sequence>

			</xsl:if>

			<fo:page-sequence master-reference="letters" initial-page-number="1">
				<xsl:apply-templates select="header" />
				<xsl:apply-templates select="footer" />
				<xsl:apply-templates select="body" />

			</fo:page-sequence>
		</fo:root>
	</xsl:template>

	<xsl:template match="header">
		<fo:static-content flow-name="xsl-region-before"
			font-family="Arial" font-size="8pt">
			<xsl:apply-templates />
		</fo:static-content>
	</xsl:template>

	<xsl:template match="body">
		<xsl:param name="first" />
		<fo:flow flow-name="xsl-region-body" font-family="Arial"
			font-size="10pt">
			<xsl:apply-templates>
				<xsl:with-param name="dataset" select="$values" />
			</xsl:apply-templates>
			<xsl:choose>
				<xsl:when test="$first and $first='true'">
					<fo:block id="first" />
				</xsl:when>
				<xsl:otherwise>
					<fo:block id="main" />
				</xsl:otherwise>
			</xsl:choose>
		</fo:flow>
	</xsl:template>

	<xsl:template match="footer">
		<fo:static-content flow-name="xsl-region-after"
			font-family="Arial" font-size="8pt">
			<xsl:apply-templates />
		</fo:static-content>
	</xsl:template>

	<xsl:template match="paragraph">
		<xsl:param name="dataset" />
		<xsl:call-template name="block-setup">
			<xsl:with-param name="dataset" select="$dataset" />
		</xsl:call-template>
	</xsl:template>

	<xsl:template match="block">
		<xsl:param name="dataset" />
		<fo:block>
			<xsl:call-template name="block-setup">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:call-template>
		</fo:block>
	</xsl:template>

	<!-- table of contents -->
	<xsl:template match="toc">
		<xsl:param name="dataset"/>
		<fo:flow flow-name="xsl-region-body" font-family="Arial" font-size="15pt" font-weight="normal">
			<xsl:if test=".!=''">
				<fo:block font-family="Arial" font-size="15pt" font-weight="normal">
					<xsl:value-of select="." />
				</fo:block>
			</xsl:if>

			<!-- table of contents 
			<xsl:apply-templates select="$template//heading1" mode="toc"/>
			<xsl:apply-templates select="$template//heading1 | $template//heading2 | $template//heading3 | $template//heading4" mode="toc"/>
      		-->
			<xsl:apply-templates select="$template//heading1 | $template//heading2" mode="toc"/>

		</fo:flow>
	</xsl:template>

	<xsl:template match="heading1" mode="toc">

		<xsl:variable name="chapter-number">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1. " />
		</xsl:variable>

		<xsl:variable name="reference">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1" />
		</xsl:variable>
		<fo:block text-align='justify' text-align-last="justify" space-before="5mm" font-size="9pt" font-weight="bold" >

			<!-- the actual content -->
			<fo:basic-link>

				<xsl:attribute name='internal-destination'>chapter-refid-<xsl:value-of select="$reference"/>
				</xsl:attribute>

				<!-- insert the chapter number -->
				<!-- the introduction comes before chapter one and has no chapter number -->

				<xsl:value-of select="$chapter-number"/>

				<xsl:apply-templates select="name"/>

				<!-- the default leader width is 0,12pt,100% which works for this -->
        &#160;
				<fo:leader leader-pattern='space' rule-thickness='.2pt' leader-alignment='reference-area' font-size="10pt"/>
        &#160;

				<!-- can click on page number -->

				<fo:page-number-citation>
					<xsl:attribute name='ref-id'>chapter-refid-<xsl:value-of select="$reference"/>
					</xsl:attribute>
				</fo:page-number-citation>

			</fo:basic-link>

		</fo:block>

	</xsl:template>

	<xsl:template match="heading2" mode="toc">
		<xsl:variable name="chapter-number">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1. " />
		</xsl:variable>

		<xsl:variable name="reference">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1" />
		</xsl:variable>
		<fo:block text-align='justify' text-align-last="justify" font-weight="normal" space-after="3pt" font-size="9pt"  margin-left="1cm" >

			<!-- the actual content -->
			<fo:basic-link>

				<xsl:attribute name='internal-destination'>chapter-refid-<xsl:value-of select="$reference"/>
				</xsl:attribute>

				<!-- insert the chapter number -->
				<!-- the introduction comes before chapter one and has no chapter number -->

				<xsl:value-of select="$chapter-number"/>

				<xsl:apply-templates select="name"/>

				<!-- the default leader width is 0,12pt,100% which works for this -->
        &#160;
				<fo:leader leader-pattern='space' rule-thickness='.2pt' 
                   leader-alignment='reference-area' font-size="10pt"/>
        &#160;

				<!-- can click on page number -->

				<fo:page-number-citation>
					<xsl:attribute name='ref-id'>chapter-refid-<xsl:value-of select="$reference"/>
					</xsl:attribute>
				</fo:page-number-citation>

			</fo:basic-link>

		</fo:block>

	</xsl:template>
	<xsl:template match="heading3" mode="toc">
		<xsl:variable name="chapter-number">
			<xsl:number level="multiple" count="heading1 | heading2 | heading3"
				format="1.1.1. " />
		</xsl:variable>

		<xsl:variable name="reference">
			<xsl:number level="multiple" count="heading1 | heading2 | heading3"
				format="1.1.1" />
		</xsl:variable>
		<fo:block text-align='justify' text-align-last="justify" space-after="3pt" keep-with-next="always"  margin-left="2cm" 
               font-size='0.9em'>

			<!-- the actual content -->
			<fo:basic-link>

				<xsl:attribute name='internal-destination'>chapter-refid-<xsl:value-of select="$reference"/>
				</xsl:attribute>

				<!-- insert the chapter number -->
				<!-- the introduction comes before chapter one and has no chapter number -->

				<xsl:value-of select="$chapter-number"/>

				<xsl:apply-templates select="name"/>

				<!-- the default leader width is 0,12pt,100% which works for this -->
        &#160;
				<fo:leader leader-pattern='dots' rule-thickness='.2pt' 
                   leader-alignment='reference-area' font-size="10pt"/>
        &#160;

				<!-- can click on page number -->

				<fo:page-number-citation>
					<xsl:attribute name='ref-id'>chapter-refid-<xsl:value-of select="$reference"/>
					</xsl:attribute>
				</fo:page-number-citation>

			</fo:basic-link>

		</fo:block>

	</xsl:template>

	<!-- headings -->
	<xsl:template match="heading1">
		<xsl:param name="dataset" />
		<xsl:variable name="chapter-number">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1. " />
		</xsl:variable>

		<xsl:variable name="reference">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1" />
		</xsl:variable>

		<!-- heading title -->
		<fo:block font-size="15pt"
			space-before="1mm" space-after="5mm" font-weight="normal">
			<xsl:if test="position()>1">
				<xsl:attribute name="break-before">page</xsl:attribute>
			</xsl:if>
			<xsl:attribute name='id'>chapter-refid-<xsl:value-of
				select="$reference" />
			</xsl:attribute>
			<xsl:value-of select="$chapter-number" />
			&#160;
			<xsl:apply-templates select="name">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>
		<!-- display content -->
		<fo:block>
			<xsl:apply-templates select="*[not(name()='name')]">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>

		<xsl:if test='position() = last()'>
			<fo:block id='last-page'/>
		</xsl:if>
	</xsl:template>
	<xsl:template match="heading2">
		<xsl:param name="dataset" />
		<xsl:variable name="chapter-number">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1. " />
		</xsl:variable>

		<xsl:variable name="reference">
			<xsl:number level="multiple" count="heading1 | heading2"
				format="1.1" />
		</xsl:variable>
		<!-- heading title -->
		<fo:block font-size="11pt" font-weight="bold" space-before="1mm" space-after="0.45cm">
			<xsl:attribute name='id'>chapter-refid-<xsl:value-of
				select="$reference" />
			</xsl:attribute>
			<xsl:value-of select="$chapter-number"/>
			<xsl:apply-templates select="name">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>
		<!-- display content -->
		<fo:block>
			<xsl:apply-templates select="*[not(name()='name')]">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>
	</xsl:template>
	<xsl:template match="heading3">
		<xsl:param name="dataset" />
		<xsl:variable name="chapter-number">
			<xsl:number level="multiple" count="heading1 | heading2 | heading3"
				format="1.1.1. " />
		</xsl:variable>

		<xsl:variable name="reference">
			<xsl:number level="multiple" count="heading1 | heading2 | heading3"
				format="1.1.1" />
		</xsl:variable>
		<fo:block font-size="10pt" font-style="italic" space-before="1mm" space-after="1mm">
			<xsl:attribute name='id'>chapter-refid-<xsl:value-of
				select="$reference" />
			</xsl:attribute>
			<xsl:value-of select="$chapter-number"/>
			<xsl:apply-templates select="name">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>
		<!-- display content -->
		<fo:block>
			<xsl:apply-templates select="*[not(name()='name')]">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>
	</xsl:template>
	<xsl:template match="heading4">
		<xsl:param name="dataset" />
		<fo:block font-size="14pt" space-before="5mm" space-after="10mm">
			<xsl:apply-templates>
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:block>
	</xsl:template>

	<!-- font styles -->
	<xsl:template match="bold">
		<xsl:param name="dataset" />
		<fo:inline font-weight="bold">
			<xsl:apply-templates>
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:inline>
	</xsl:template>
	<xsl:template match="underline">
		<xsl:param name="dataset" />
		<fo:inline text-decoration="underline">
			<xsl:apply-templates>
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:inline>
	</xsl:template>
	<xsl:template match="italic">
		<xsl:param name="dataset" />
		<fo:inline font-style="italic">
			<xsl:apply-templates>
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:inline>
	</xsl:template>

	<xsl:template match="image">
		<xsl:param name="dataset" />
		<fo:external-graphic>
			<xsl:attribute name="src">
				<xsl:apply-templates>
					<xsl:with-param name="dataset" select="$dataset" />
				</xsl:apply-templates>				
			</xsl:attribute>
			<xsl:if test="@height">
				<xsl:attribute name="content-height">
					<xsl:value-of select="@height" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@width">
				<xsl:attribute name="content-width">
					<xsl:value-of select="@width" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@content-type">
				<xsl:attribute name="content-type">
					<xsl:value-of select="@content-type" />
				</xsl:attribute>
			</xsl:if>
		</fo:external-graphic>
	</xsl:template>

	<xsl:template match="src">
		<xsl:param name="dataset" />
		<xsl:apply-templates>
			<xsl:with-param name="dataset" select="$dataset" />
		</xsl:apply-templates>
	</xsl:template>

	<!-- lists -->
	<xsl:template match="list">
		<xsl:param name="dataset" />
		<fo:list-block>
			<xsl:if test="not(ancestor::list)">
				<xsl:attribute name="provisional-distance-between-starts">5mm</xsl:attribute>
				<!-- <xsl:attribute name="start-indent">5mm</xsl:attribute> -->
			</xsl:if>
			<xsl:apply-templates select="list-item">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:list-block>
	</xsl:template>

	<xsl:template match="list-item">
		<xsl:param name="dataset" />
		<xsl:variable name="item-number">
			<xsl:number level="single" count="list-item"
				format="1. " />
		</xsl:variable>
		<fo:list-item>
			<fo:list-item-label end-indent="label-end(  )">
				<fo:block>
					<xsl:choose>
						<xsl:when test="@label">
							<xsl:value-of select="@label"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$item-number"/>
						</xsl:otherwise>
					</xsl:choose>
				</fo:block>
			</fo:list-item-label>
			<fo:list-item-body start-indent="body-start(  )">
				<fo:block>
					<xsl:apply-templates>
						<xsl:with-param name="dataset" select="$dataset" />
					</xsl:apply-templates>
				</fo:block>

			</fo:list-item-body>
		</fo:list-item>
	</xsl:template>

	<!-- value search -->
	<xsl:template match="value">
		<xsl:param name="dataset" />
		<xsl:variable name="tmpValName">
			<xsl:value-of select="@name" />
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$dataset">
				<xsl:choose>
					<xsl:when test="$dataset/tagvalue[@name=$tmpValName] != ''">
						<xsl:value-of select="$dataset/tagvalue[@name=$tmpValName]" />
					</xsl:when>
					<xsl:when test="following-sibling::* or preceding-sibling::*"/>
					<xsl:otherwise>
						<xsl:text>&#160;</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$values/tagvalue[@name=$tmpValName] != ''">
						<xsl:value-of select="$values/tagvalue[@name=$tmpValName]" />
					</xsl:when>
					<xsl:when test="following-sibling::* or preceding-sibling::*"/>
					<xsl:otherwise>
						<xsl:text>&#160;</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- page number -->
	<xsl:template match="page-number">
		<fo:page-number />
	</xsl:template>

	<xsl:template match="page-total">
		<fo:page-number-citation ref-id="main" />
	</xsl:template>


	<!-- line -->
	<xsl:template match="line">
		<fo:block border-bottom-color="black" border-bottom-style="solid"
			border-bottom-width="thin">
		</fo:block>
	</xsl:template>

	<!-- conditional -->
	<xsl:template match="if">
		<xsl:param name="dataset" />
		<xsl:variable name="tmpValName">
			<xsl:value-of select="@name" />
		</xsl:variable>
		<xsl:variable name="tmpValData">
			<xsl:choose>
				<xsl:when test="$dataset/tagvalue[@name=$tmpValName]">
					<xsl:value-of select="$dataset/tagvalue[@name=$tmpValName]" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$values/tagvalue[@name=$tmpValName]" />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="@condition[.='equal']">
				<xsl:if test="@value=$tmpValData">
					<xsl:apply-templates>
						<xsl:with-param name="dataset" select="$dataset" />
					</xsl:apply-templates>
				</xsl:if>
			</xsl:when>
			<xsl:when test="@condition[.='not_equal']">
				<xsl:if test="@value!=$tmpValData">
					<xsl:apply-templates>
						<xsl:with-param name="dataset" select="$dataset" />
					</xsl:apply-templates>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="@value=$tmpValData">
					<xsl:apply-templates>
						<xsl:with-param name="dataset" select="$dataset" />
					</xsl:apply-templates>
				</xsl:if>	
			</xsl:otherwise>
		</xsl:choose>


	</xsl:template>

	<xsl:template match="pageset">
		<xsl:variable name="pagesetid">
			<xsl:value-of select="@id" />
		</xsl:variable>
		<xsl:variable name="pagedef" select="child::node()" />


		<xsl:for-each select="$values/pages[@id=$pagesetid]/page">
			<xsl:variable name="pagedef2" select=".|$pagedef" />
			<xsl:call-template name="page">
				<xsl:with-param name="pagedef" select="$pagedef" />
				<xsl:with-param name="dataset" select="self::node()" />
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="page">
		<xsl:param name="pagedef" />
		<xsl:param name="dataset" />
		<fo:block break-before="page">
			<xsl:apply-templates select="$pagedef">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>

		</fo:block>
	</xsl:template>
	<xsl:template match="page">
		<xsl:param name="dataset" />
		<fo:block break-before="page">
			<xsl:apply-templates>
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>

		</fo:block>
	</xsl:template>

	<xsl:template match="table">
		<xsl:param name="dataset" />
		<fo:table table-layout="fixed">
			<xsl:if test="@border-width">
				<xsl:attribute name="border-width">
					<xsl:value-of select="@border-width"/>
				</xsl:attribute>
				<xsl:attribute name="border-style">solid</xsl:attribute>
				<xsl:attribute name="border-color">
					<xsl:value-of select="@border-color"/>
				</xsl:attribute>
			</xsl:if>
			<!-- setup colum defs -->
			<xsl:apply-templates select="table-column">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>

			<!-- setup headers -->
			<fo:table-header>
				<fo:table-row>
					<xsl:apply-templates select="table-headers">
						<xsl:with-param name="dataset" select="$dataset" />
					</xsl:apply-templates>
				</fo:table-row>
			</fo:table-header>

			<!-- setup rows -->
			<fo:table-body>
				<xsl:apply-templates select="table-data-row|table-row">
					<xsl:with-param name="dataset" select="$dataset" />
				</xsl:apply-templates>
			</fo:table-body>
		</fo:table>
	</xsl:template>

	<xsl:template match="table-column">
		<xsl:param name="dataset" />

		<fo:table-column>
			<xsl:attribute name="column-width">
				<xsl:value-of select="@width" />
			</xsl:attribute>
			<xsl:attribute name="background-color">
				<xsl:value-of select="@background-color" />
			</xsl:attribute>
			<xsl:if test="@border-width">
				<xsl:attribute name="border-width">
					<xsl:value-of select="@border-width"/>
				</xsl:attribute>
				<xsl:attribute name="border-style">solid</xsl:attribute>
				<xsl:attribute name="border-color">
					<xsl:value-of select="@border-color"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates select="table-column">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:apply-templates>
		</fo:table-column>
	</xsl:template>

	<xsl:template match="table-headers">
		<xsl:param name="dataset" />

		<xsl:apply-templates>
			<xsl:with-param name="dataset" select="$dataset" />
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="table-header">
		<xsl:param name="dataset" />
		<fo:table-cell>
			<xsl:if test="@colspan">
				<xsl:attribute name="number-columns-spanned">
					<xsl:value-of select="@colspan" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="ancestor::table[@border-width!=''] and (not(ancestor::table/@border-mode) or ancestor::table/@border-mode!='outer')">
				<xsl:attribute name="border-width">
					<xsl:value-of select="ancestor::table/@border-width"/>
				</xsl:attribute>
				<xsl:attribute name="border-style">solid</xsl:attribute>
			</xsl:if>
			<xsl:if test="@border-top-style">
				<xsl:attribute name="border-top-style">
					<xsl:value-of select="@border-top-style" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@border-bottom-style">
				<xsl:attribute name="border-bottom-style">
					<xsl:value-of select="@border-bottom-style" />
				</xsl:attribute>
			</xsl:if>

			<xsl:choose>
				<xsl:when test="@border-color[.!='']">
					<xsl:attribute name="border-color">
						<xsl:value-of select="@border-color"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test="ancestor::table[@border-color!=''] and (not(ancestor::table/@border-mode) or ancestor::table/@border-mode!='outer')">
					<xsl:attribute name="border-color">
						<xsl:value-of select="ancestor::table/@border-color"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<!-- do nothing -->
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="not(@padding-left)">
				<xsl:attribute name="padding-left">0mm</xsl:attribute>
				<xsl:attribute name="padding-before">0mm</xsl:attribute>
			</xsl:if>
			<xsl:if test="not(@padding-right)">
				<xsl:attribute name="padding-right">0mm</xsl:attribute>
				<xsl:attribute name="padding-after">0mm</xsl:attribute>
			</xsl:if>

			<xsl:call-template name="block-setup">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:call-template>
		</fo:table-cell>
	</xsl:template>

	<xsl:template match="table-data-row">
		<xsl:param name="dataset" />
		<xsl:variable name="tableid" select="@dataset"/>
		<xsl:variable name="break-after" select="@break-after"/>
		<xsl:variable name="tabledata" select="$dataset/table[@id=$tableid]/row" />
		<xsl:variable name="rowdef" select="child::node()" />
		<xsl:for-each select="$tabledata">
			<fo:table-row>

				<xsl:if test="$break-after">
					<xsl:attribute name="break-after">
						<xsl:value-of select="$break-after" />
					</xsl:attribute>
				</xsl:if>
				<xsl:call-template name="table-data-row2">
					<xsl:with-param name="rowdef" select="$rowdef" />
					<xsl:with-param name="rowdata" select="self::node()" />
				</xsl:call-template>
			</fo:table-row>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="table-data-row2">
		<xsl:param name="rowdef" />
		<xsl:param name="rowdata" />
		<xsl:apply-templates select="$rowdef">
			<xsl:with-param name="dataset" select="$rowdata" />
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="table-cell">
		<xsl:param name="dataset" />
		<fo:table-cell>
			<xsl:if test="@colspan">
				<xsl:attribute name="number-columns-spanned">
					<xsl:value-of select="@colspan" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@rowspan">
				<xsl:attribute name="number-rows-spanned">
					<xsl:value-of select="@rowspan" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@display-align">
				<xsl:attribute name="display-align">
					<xsl:value-of select="@display-align" />
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@border-width[.!='']">
					<xsl:attribute name="border-width">
						<xsl:value-of select="@border-width"/>
					</xsl:attribute>
					<xsl:attribute name="border-style">solid</xsl:attribute>
				</xsl:when>
				<xsl:when test="ancestor::table[@border-width!=''] and (not(ancestor::table/@border-mode) or ancestor::table/@border-mode!='outer')">
					<xsl:attribute name="border-width">
						<xsl:value-of select="ancestor::table/@border-width"/>
					</xsl:attribute>
					<xsl:attribute name="border-style">solid</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<!-- do nothin-->
				</xsl:otherwise>
			</xsl:choose>

			<xsl:choose>
				<xsl:when test="@border-color[.!='']">
					<xsl:attribute name="border-color">
						<xsl:value-of select="@border-color"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test="ancestor::table[@border-color!=''] and (not(ancestor::table/@border-mode) or ancestor::table/@border-mode!='outer')">
					<xsl:attribute name="border-color">
						<xsl:value-of select="ancestor::table/@border-color"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<!-- do nothin-->
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="not(@padding-left)">
				<xsl:attribute name="padding-left">0mm</xsl:attribute>
				<xsl:attribute name="padding-before">0mm</xsl:attribute>
			</xsl:if>
			<xsl:if test="not(@padding-right)">
				<xsl:attribute name="padding-right">0mm</xsl:attribute>
				<xsl:attribute name="padding-after">0mm</xsl:attribute>
			</xsl:if>
			<!--
				<fo:block> <xsl:if test="@topline"> <xsl:attribute
				name="border-top">1pt solid black</xsl:attribute> </xsl:if> <xsl:if
				test="@bottomline"> <xsl:attribute name="border-bottom">1pt solid
				black</xsl:attribute> </xsl:if> <xsl:if test="@leftline">
				<xsl:attribute name="border-left">1pt solid black</xsl:attribute>
				</xsl:if> <xsl:if test="@rightline"> <xsl:attribute
				name="border-right">1pt solid black</xsl:attribute> </xsl:if>
				<xsl:if test="@align"> <xsl:attribute
				name="text-align"><xsl:value-of select="@align"/></xsl:attribute>
				</xsl:if> <xsl:apply-templates> <xsl:with-param name="dataset"
				select="$dataset"/> </xsl:apply-templates> </fo:block>
			-->
			<xsl:call-template name="block-setup">
				<xsl:with-param name="dataset" select="$dataset" />
			</xsl:call-template>

		</fo:table-cell>
	</xsl:template>

	<xsl:template match="table-row">
		<xsl:param name="dataset" />
		<fo:table-row>

			<xsl:call-template name="table-data-row2">
				<xsl:with-param name="rowdef" select="child::node()" />
				<xsl:with-param name="rowdata" select="$dataset" />
			</xsl:call-template>
		</fo:table-row>
	</xsl:template>

	<xsl:template name="block-setup">
		<xsl:param name="dataset" />
		<fo:block>
			<!--
				<xsl:if test="ancestor-or-self::node()=$template/letter/body">
				<xsl:attribute name="space-before">5pt</xsl:attribute>
				<xsl:attribute name="space-after">5pt</xsl:attribute> </xsl:if>
			-->
			<xsl:if test="@preserve-space='true'">
				<xsl:attribute name="linefeed-treatment">preserve</xsl:attribute>
				<xsl:attribute name="white-space-collapse">white-space-collapse</xsl:attribute>
			</xsl:if>
			<xsl:if test="@color">
				<xsl:attribute name="color">
					<xsl:value-of select="@color" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@background-color">
				<xsl:attribute name="background-color">
					<xsl:value-of select="@background-color" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@topline">
				<xsl:attribute name="border-top">thin solid black</xsl:attribute>
			</xsl:if>
			<xsl:if test="@bottomline">
				<xsl:attribute name="border-bottom">thin solid black</xsl:attribute>
			</xsl:if>
			<xsl:if test="@leftline">
				<xsl:attribute name="border-left">thin solid black</xsl:attribute>
			</xsl:if>
			<xsl:if test="@rightline">
				<xsl:attribute name="border-right">thin solid black</xsl:attribute>
			</xsl:if>
			<xsl:if test="@align">
				<xsl:attribute name="text-align">
					<xsl:value-of select="@align" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@margin-top">
				<xsl:attribute name="margin-top">
					<xsl:value-of select="@margin-top" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@margin-left">
				<xsl:attribute name="margin-left">
					<xsl:value-of select="@margin-left" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@margin-right">
				<xsl:attribute name="margin-right">
					<xsl:value-of select="@margin-right" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@margin-bottom">
				<xsl:attribute name="margin-bottom">
					<xsl:value-of select="@margin-bottom" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@padding-top">
				<xsl:attribute name="padding-top">
					<xsl:value-of select="@padding-top" />
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@padding-left">
					<xsl:attribute name="padding-left">
						<xsl:value-of select="@padding-left" />
					</xsl:attribute>
					<xsl:attribute name="padding-before">
						<xsl:value-of select="@padding-left" />
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="padding-left">0</xsl:attribute>
					<xsl:attribute name="padding-before">0</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="@padding-right">
					<xsl:attribute name="padding-right">
						<xsl:value-of select="@padding-right" />
					</xsl:attribute>
					<xsl:attribute name="padding-after">
						<xsl:value-of select="@padding-right" />
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="padding-right">0</xsl:attribute>
					<xsl:attribute name="padding-after">0</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@padding-bottom">
				<xsl:attribute name="padding-bottom">
					<xsl:value-of select="@padding-bottom" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@font-size">
				<xsl:attribute name="font-size">
					<xsl:value-of select="@font-size" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@font-family">
				<xsl:attribute name="font-family">
					<xsl:value-of select="@font-family" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@break-before">
				<xsl:attribute name="break-before">
					<xsl:value-of select="@break-before" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@break-after">
				<xsl:attribute name="break-after">
					<xsl:value-of select="@break-after" />
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@pre">
				<!--				<xsl:attribute name="white-space-collapse">false</xsl:attribute>-->
				<xsl:attribute name="linefeed-treatment">preserve</xsl:attribute>
				<!--				<xsl:attribute name="white-space-treatment">preserve</xsl:attribute>-->
				<xsl:attribute name="wrap-option">wrap</xsl:attribute>

			</xsl:if>
			<xsl:choose>
				<xsl:when test="@pre">
					<xsl:variable name="cont" select="."/>
					<fo:list-block>
						<xsl:for-each select="tokenize($cont,'&#xa;')">
							<xsl:variable name="regel" select="."/>
							<xsl:variable name="tabs" select="string-length(substring-before($regel,substring(normalize-space($regel),1,1)))"/>
							<xsl:variable name="rest" select="substring-after($regel,substring(normalize-space($regel),1,1))"/>
							<xsl:analyze-string regex="^[ \t]*(\w\.*)[ \t]+(.*)$" select="$regel">
								<xsl:matching-substring>
									<fo:list-item>
										<xsl:attribute name="start-indent">
											<xsl:value-of select="$tabs"/>cm</xsl:attribute>
										<fo:list-item-label end-indent="label-end()">
											<fo:block>
												<xsl:value-of select="regex-group(1)"/>
											</fo:block>
										</fo:list-item-label>
										<fo:list-item-body>
											<xsl:attribute name="start-indent">
												<xsl:value-of select="$tabs+1"/>cm</xsl:attribute>
											<fo:block>
												<xsl:value-of select="regex-group(2)"/>
											</fo:block>
										</fo:list-item-body>
									</fo:list-item>
								</xsl:matching-substring>
								<xsl:non-matching-substring>
									<fo:list-item>
										<xsl:attribute name="start-indent">
											<xsl:value-of select="$tabs"/>cm</xsl:attribute>
										<fo:list-item-label>
											<fo:block/>
										</fo:list-item-label>
										<fo:list-item-body>
											<fo:block>
												<xsl:if test="string-length(normalize-space($regel))=0">&#160;</xsl:if>
												<xsl:value-of select="$regel"/>
											</fo:block>
										</fo:list-item-body>
									</fo:list-item>
								</xsl:non-matching-substring>

							</xsl:analyze-string>

							<!-- 								<xsl:variable name="tablabel" select=".[1]"/>
									<xsl:variable name="tabtekst" select=".[2]"/>
									<fo:list-item>
										<fo:list-item-label><xsl:value-of select="$tablabel"/></fo:list-item-label>
										<fo:list-item-body><xsl:value-of select="$tabtekst"/></fo:list-item-body>								
									</fo:list-item>
									<fo:block>
										<xsl:attribute name="start-indent"><xsl:value-of select="$tabs"/>cm</xsl:attribute>
										<xsl:value-of select="replace($regel,'&#9;','___')" disable-output-escaping="yes"/>
									</fo:block> -->

						</xsl:for-each>
					</fo:list-block>
					<!--
					<xsl:variable name="tabje">&lt;fo:leader leader-pattern=&#34;space&#34; leader-length=&#34;3mm;&#34; leader-alignment=&#34;reference-area&#34;/&gt;</xsl:variable>
					<xsl:variable name="cont" select="."/>
					
					<xsl:value-of select="replace($cont,'&#9;',$tabje)" disable-output-escaping="yes"/>
				  -->	
				</xsl:when>
				<xsl:when test="not(*) and not(normalize-space())">
					<xsl:text>&#160;</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates>
						<xsl:with-param name="dataset" select="$dataset" />
					</xsl:apply-templates>
				</xsl:otherwise>
			</xsl:choose>
		</fo:block>
	</xsl:template>
</xsl:stylesheet>