<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="attr[@fieldtype='filteringselect']">
		<xsl:variable name="formid" select="$formid" />
		<xsl:if test="not(@mode) and (not(contains(@lock,'true')) or not(@lock))">
			
			<xsl:variable name="v_req">
				<xsl:choose>
					<xsl:when test="@required[.='true']">true</xsl:when>
					<xsl:otherwise>false</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="v_hidearrow">
				<xsl:choose>
					<xsl:when test="@noarrow[.='true']">false</xsl:when>
					<xsl:otherwise>true</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			
			<select data-dojo-type="chy/form/FilteringSelect">
    			<xsl:if test="@id[.!='']"><xsl:attribute name="id"><xsl:value-of select="$formid"/>-<xsl:value-of select="@id"/></xsl:attribute></xsl:if>
				<xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute>
				<xsl:if test="@readonly[.='true'] or ../@readonly[.='true']"><xsl:attribute name="readonly">true</xsl:attribute></xsl:if>
				<xsl:choose>
					<xsl:when test="@required[.='true']"><xsl:attribute name="required"><xsl:value-of select="@required"/></xsl:attribute></xsl:when>
					<xsl:otherwise><xsl:attribute name="required">false</xsl:attribute></xsl:otherwise>
				</xsl:choose>
				<xsl:attribute name="data-dojo-props">
					dataUrl:'<xsl:value-of select="data_url" />',
					formId:'<xsl:value-of select="$formid"/>',
					val:'<xsl:value-of select="content" />',
					chyValidateStr: '<xsl:value-of select="@validate"/>'
				</xsl:attribute>
    			
				<!-- Content -->
				<xsl:for-each select="item">
					<option>
						<xsl:if test="../@default=@value and string-length(../content) = 0"><xsl:attribute name="selected"></xsl:attribute></xsl:if>
						<xsl:if test="normalize-space(../content)=normalize-space(@value)"><xsl:attribute name="selected"></xsl:attribute></xsl:if>
						<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
						<xsl:choose>
							<xsl:when test="@label[.!='']"><xsl:value-of select="@label"/></xsl:when>
							<xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
						</xsl:choose>
					</option>
				</xsl:for-each>
			</select>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
