<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="attr[@fieldtype='navbar']">

		<!--
			 <div class="tabBox">
					<div class="tab">
						<ul>
							<li class="active"><a href="#">Organisatie</a></li>
							<li><a href="#">Contact personen</a></li>
							<li><a href="#">Prelead Lijst</a></li>
							<li><a href="#">another tab</a></li>
						</ul>
					</div>
				</div>
		-->
		<xsl:if test="item">
			<div class="tabBox">
				<div class="tab">
					<ul class="nav nav-tabs">
						<xsl:for-each select="item">
							<li>
								<xsl:attribute name="id">
									<xsl:value-of select="@id" />
								</xsl:attribute>
								<xsl:attribute name="class">
									<xsl:choose>
										<xsl:when test="@class[.!='']">
											<xsl:value-of select="@class" />
											<xsl:if test="../@active=@id">
												<xsl:attribute name="class"> active</xsl:attribute>
											</xsl:if>
										</xsl:when>
										<xsl:otherwise>
											<xsl:if test="../@active=@id">
												<xsl:attribute name="class"> active</xsl:attribute>
											</xsl:if>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:attribute>
								<a>
									<xsl:if test="@class[.='dropdown']">
										<xsl:attribute name="class">dropdown-toggle</xsl:attribute>
									</xsl:if>
									<xsl:attribute name="onclick">
							setNavBarActive('<xsl:value-of select="@id" />');
										<xsl:choose>
											<xsl:when test="@url">
												<xsl:call-template name="make_link">
													<xsl:with-param name="link">
														<xsl:value-of select="@url" />
													</xsl:with-param>
												</xsl:call-template>
											</xsl:when>
											<xsl:when test="@class[.='dropdown']">
									toggleDisplay('<xsl:value-of select="@id" />');
											</xsl:when>
										</xsl:choose>
									</xsl:attribute>
									<xsl:value-of select="@label" />
									<xsl:if test="@class[.='dropdown']">
										<b class="caret">&#160;</b>
									</xsl:if>
								</a>
								<xsl:if test="@class[.='dropdown']">
									<ul class="dropdown-menu">
										<xsl:for-each select="subitem">
											<li>
												<a>
													<xsl:attribute name="onclick">
											setNavBarActive('<xsl:value-of select="../@id" />');
											toggleDisplay('<xsl:value-of select="../@id" />');
														<xsl:call-template name="make_link">
															<xsl:with-param name="link">
																<xsl:value-of select="@url" />
															</xsl:with-param>
														</xsl:call-template>
													</xsl:attribute>
													<xsl:value-of select="@label" />
												</a>
											</li>
										</xsl:for-each>
									</ul>
								</xsl:if>
							</li>
						</xsl:for-each>
					</ul>
				</div>
			</div>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
