<?xml version="1.0"?>

<!-- 

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
	<xsl:template match="item[@fieldtype='q_XXX']">
		<xsl:param name="form_id"/>
		<xsl:param name="overrides"/>
			<!-- Display question text -->
			<xsl:call-template name="questiontext"/>
			
			<!-- Display question answer -->
			<td>
				<xsl:if test="$overrides and $overrides/@styleCSS[.!='']">
						<xsl:attribute name="style">
							<xsl:value-of select=" $overrides/@styleCSS"/>
						</xsl:attribute>
				</xsl:if>
				<xsl:if test="$overrides and $overrides/@rowspan[.!='']">
						<xsl:attribute name="rowspan">
							<xsl:value-of select=" $overrides/@rowspan"/>
						</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="class">
					<xsl:choose>
						<xsl:when test="@class[.!='']">
							<xsl:value-of select="@class"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>questionanswer</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
				<xsl:choose>
					<xsl:when test="$overrides and $overrides/@colspan[.!='']"><xsl:attribute name="colspan"><xsl:value-of select="$overrides/@colspan" /></xsl:attribute></xsl:when>
					<xsl:when test="@fspan[.!='']"><xsl:attribute name="colspan"><xsl:value-of select="@fspan" /></xsl:attribute></xsl:when>
					<xsl:otherwise></xsl:otherwise>
				</xsl:choose>
				<xsl:if test="@fwidth[.!='']"><xsl:attribute name="width"><xsl:value-of select="@fwidth" /></xsl:attribute></xsl:if>
				
			</td>
			<!-- hidden for processing formitem by dd -->
			<input type="hidden">
				<xsl:attribute name="name"><xsl:value-of select="$form_id"/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="@id"/></xsl:attribute>
			</input>
	</xsl:template>
</xsl:stylesheet>