<?xml version="1.0"?>

<!-- 

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
	<xsl:template match="item[@fieldtype='q_comment']">
		<xsl:param name="form_id"/>
		<xsl:param name="overrides"/>
			<!-- Display question text -->
			<xsl:choose>
				<xsl:when test="contains(./label, '|')">
					<td class="questiontext">
						<xsl:value-of select="substring-before(./label, '|')" disable-output-escaping="yes" />
					</td>
					<td class="questiontext">
						<xsl:value-of select="substring-after(./label, '|')" disable-output-escaping="yes" />
					</td>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="questiontext"/>	
				</xsl:otherwise>
			</xsl:choose>
			
			
			<!-- hidden for processing formitem by dd -->
			<input type="hidden" >
				<xsl:attribute name="name"><xsl:value-of select="$form_id"/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="@id"/></xsl:attribute>
			</input>
	</xsl:template>
</xsl:stylesheet>