<?xml version="1.0"?>

<!-- 

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
	<xsl:template match="item[@fieldtype='q_text' or @fieldtype='q_currency' or @fieldtype='q_currency1000' or @fieldtype='q_number' or @fieldtype='q_year' or @fieldtype='q_time']">
		<xsl:param name="form_id"/>
		<xsl:param name="overrides"/>
		<xsl:variable name="formid" select="$formid" />
			<!-- Display question text -->
			<xsl:call-template name="questiontext">
				<xsl:with-param name="overrides" select="$overrides" />
			</xsl:call-template>
			
			<!-- Display question answer -->
			<td>
				<xsl:if test="$overrides and $overrides/@styleCSS[.!='']">
						<xsl:attribute name="style">
							<xsl:value-of select=" $overrides/@styleCSS"/>
						</xsl:attribute>
				</xsl:if>
				<xsl:if test="$overrides and $overrides/@rowspan[.!='']">
						<xsl:attribute name="rowspan">
							<xsl:value-of select=" $overrides/@rowspan"/>
						</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="class">
					<xsl:choose>
						<xsl:when test="@class[.!='']">
							<xsl:value-of select="@class"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>questionanswer</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:if test="$overrides and $overrides/@class[.!='']"><xsl:text> </xsl:text><xsl:value-of select="$overrides/@class" /></xsl:if>
				</xsl:attribute>
				<xsl:choose>
					<xsl:when test="$overrides and $overrides/@colspan[.!='']"><xsl:attribute name="colspan"><xsl:value-of select="$overrides/@colspan" /></xsl:attribute></xsl:when>
					<xsl:when test="@fspan[.!='']"><xsl:attribute name="colspan"><xsl:value-of select="@fspan" /></xsl:attribute></xsl:when>
					<xsl:otherwise></xsl:otherwise>
				</xsl:choose>
				<xsl:if test="@fwidth[.!='']"><xsl:attribute name="width"><xsl:value-of select="@fwidth" /></xsl:attribute></xsl:if>
	       		<xsl:choose>
	       			<xsl:when test="../@readonly[.='true'] and @fieldtype[.!='q_currency1000'] and @fieldtype[.!='q_currency'] and @fieldtype[.!='q_number']">
	       				<xsl:choose>
	       					<xsl:when test="starts-with(content,'http')"><a target="_new"><xsl:attribute name="href"><xsl:value-of select="content"/></xsl:attribute><xsl:value-of select="content"/></a></xsl:when>
	       					<xsl:when test="starts-with(content,'www.')"><a target="_new"><xsl:attribute name="href">http://<xsl:value-of select="content"/></xsl:attribute><xsl:value-of select="content"/></a></xsl:when>
							<xsl:when test="contains(@validate,'email') and normalize-space(content)!=''"><a target="_new"><xsl:attribute name="href">mailto:<xsl:value-of select="content"/></xsl:attribute><xsl:value-of select="content"/></a></xsl:when>
							<xsl:when test="normalize-space(content)!=''"><xsl:value-of select="content"/></xsl:when>
							<xsl:otherwise><xsl:value-of select="@default"/></xsl:otherwise>
						</xsl:choose>
	       			</xsl:when>
	       			<xsl:otherwise>
	       				<xsl:variable name="v_value">
							<xsl:choose>
								<xsl:when test="normalize-space(content)!=''"><xsl:value-of select="content"/></xsl:when>
								<xsl:otherwise><xsl:value-of select="@default"/></xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
	       				<input class="text_item"  >
			       			<xsl:attribute name="type">text</xsl:attribute>
							<xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute>
							<xsl:attribute name="id"><xsl:value-of select="$formid"/>-<xsl:value-of select="@id"/></xsl:attribute>
							<xsl:attribute name="value"><xsl:value-of select="$v_value"/></xsl:attribute>
						    <xsl:if test="@maxlength[.!='' and .!='0']"><xsl:attribute name="maxlength"><xsl:value-of select="@maxlength"/></xsl:attribute></xsl:if>
							<xsl:if test="@size[.!='']"><xsl:attribute name="size"><xsl:value-of select="@size"/></xsl:attribute></xsl:if>
			       			<xsl:if test="@readonly[.='true'] or ../@readonly[.='true']"><xsl:attribute name="readonly">true</xsl:attribute></xsl:if>
							<xsl:if test="@required[.='true']"><xsl:attribute name="required"><xsl:value-of select="@required"/></xsl:attribute></xsl:if>
							<xsl:choose>
								<xsl:when test="@fieldtype[.='q_text']">
									<xsl:attribute name="data-dojo-type">chy/form/ValidationTextBox</xsl:attribute>
									<xsl:attribute name="data-dojo-props">
										        <xsl:if test="@readonly[.='true'] or ../@readonly[.='true']">readonly:true,</xsl:if>
										        <xsl:if test="@readonly[.='true']">baseClass:'dijitReadOnly',</xsl:if>
										        <xsl:if test="../@readonly[.='true']">baseClass:'dijitReadOnlyForm',</xsl:if>
												formId: '<xsl:value-of select="$formid"/>',
												chyValidateStr: '<xsl:value-of select="@validate"/>',
												value: '<xsl:value-of select="$v_value"/>'
									</xsl:attribute>
								</xsl:when>
								<xsl:when test="@fieldtype[.='q_number']">
									<xsl:attribute name="data-dojo-type">chy/form/NumberTextBox</xsl:attribute>
									<xsl:attribute name="data-dojo-props">
										        <xsl:if test="@readonly[.='true'] or ../@readonly[.='true']">readonly:true,</xsl:if>
										        <xsl:if test="@readonly[.='true']">baseClass:'dijitReadOnly',</xsl:if>
										        <xsl:if test="../@readonly[.='true']">baseClass:'dijitReadOnlyForm',</xsl:if>
												formId: '<xsl:value-of select="$formid"/>',
										        name: '<xsl:value-of select="@id"/>',
												chyValidateStr: '<xsl:value-of select="@validate"/>',
												value: '<xsl:value-of select="$v_value"/>'
									</xsl:attribute>
								</xsl:when>
								<xsl:when test="@fieldtype[.='q_currency']">
									<xsl:attribute name="data-dojo-type">chy/form/CurrencyTextBox</xsl:attribute>
									<xsl:attribute name="data-dojo-props">
										        <xsl:if test="@readonly[.='true'] or ../@readonly[.='true']">readonly:true,</xsl:if>
										        <xsl:if test="@readonly[.='true']">baseClass:'dijitReadOnly',</xsl:if>
										        <xsl:if test="../@readonly[.='true']">baseClass:'dijitReadOnlyForm',</xsl:if>
												formId: '<xsl:value-of select="$formid"/>',
										        name: '<xsl:value-of select="@id"/>',
												chyValidateStr: '<xsl:value-of select="@validate"/>',
												value: '<xsl:value-of select="$v_value"/>',
												currency: 'EUR'
									</xsl:attribute>
								</xsl:when>
								<xsl:when test="@fieldtype[.='q_currency1000']">
									<xsl:attribute name="data-dojo-type">chy/form/Currency1000TextBox</xsl:attribute>
									<xsl:attribute name="data-dojo-props">
										        <xsl:if test="@readonly[.='true'] or ../@readonly[.='true']">readonly:true,</xsl:if>
										        <xsl:if test="@readonly[.='true']">baseClass:'dijitReadOnly',</xsl:if>
										        <xsl:if test="../@readonly[.='true']">baseClass:'dijitReadOnlyForm',</xsl:if>
												formId: '<xsl:value-of select="$formid"/>',
										        name: '<xsl:value-of select="@id"/>',
												chyValidateStr: '<xsl:value-of select="@validate"/>',
												value: '<xsl:value-of select="$v_value"/>',
												currency: 'EUR',
												constraints: {
													fractional: false
												}
									</xsl:attribute>
								</xsl:when>
								<xsl:when test="@fieldtype[.='q_year']">
									<xsl:attribute name="data-dojo-type">chy/form/NumberTextBox</xsl:attribute>
									<xsl:attribute name="data-dojo-props">
										        <xsl:if test="@readonly[.='true'] or ../@readonly[.='true']">readonly:true,</xsl:if>
										        <xsl:if test="@readonly[.='true']">baseClass:'dijitReadOnly',</xsl:if>
										        <xsl:if test="../@readonly[.='true']">baseClass:'dijitReadOnlyForm',</xsl:if>
												formId: '<xsl:value-of select="$formid"/>',
												constraints:{pattern:"0000"},
										        name: '<xsl:value-of select="@id"/>',
												chyValidateStr: '<xsl:value-of select="@validate"/>',
												value: '<xsl:value-of select="$v_value"/>'
									</xsl:attribute>
								</xsl:when>
								<xsl:when test="@fieldtype[.='q_time']">
									<xsl:attribute name="data-dojo-type">chy/form/TimeTextBox</xsl:attribute>
									<xsl:attribute name="data-dojo-props">
										        <xsl:if test="@readonly[.='true'] or ../@readonly[.='true']">readonly:true,</xsl:if>
										        <xsl:if test="@readonly[.='true']">baseClass:'dijitReadOnly',</xsl:if>
										        <xsl:if test="../@readonly[.='true']">baseClass:'dijitReadOnlyForm',</xsl:if>
												formId: '<xsl:value-of select="$formid"/>',
												constraints: {
													timePattern: 'HH:mm',
													clickableIncrement: 'T00:15',
													visibleIncrement: 'T00:15',
													visibleRange: 'T01:00'
												},
										        name: '<xsl:value-of select="@id"/>',
												chyValidateStr: '<xsl:value-of select="@validate"/>'
												<xsl:if test="normalize-space($v_value)!=''">,
													value: '<xsl:value-of select="$v_value"/>'
												</xsl:if>
									</xsl:attribute>
								</xsl:when>
							</xsl:choose>
						</input>
						<xsl:if test="@fieldtype[.='q_currency1000']"> K</xsl:if>
	       			</xsl:otherwise>
	       		</xsl:choose>				
			</td>
			<!-- hidden for processing formitem by dd -->
			<input type="hidden"  >
				<xsl:attribute name="name"><xsl:value-of select="$form_id"/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="@id"/></xsl:attribute>
			</input>
	</xsl:template>
</xsl:stylesheet>